{}
{                                                                    }
{ k i l l E O F                              (c) 1995 Peter Karlsson }
{ı}
{ Kills EOF markers in files.                                        }
{                                                                    }
{ C o m m a n d   l i n e   f o r m a t                              }
{ı}
{ KILLEOF [drive:][directory]filename1 [drive:][directory]filename2  }
{  [drive:][directory]filename1   File name to kill EOFs in          }
{  [drive:][directory]filename2   Output file                        }
{                                                                    }
{ V e r s i o n   h i s t o r y                                      }
{ı}
{  v 1.00 - 1995-10-28 -                                             }
{         - 1997-08-01 - Compiles for Win95                          }
{                                                                    }
{ C o m p i l e r s                                                  }
{ı}
{ This source has been compiled with both Borland Turbo Pascal 6.0   }
{ and SpeedPascal/2 1.0, and should compile under Virtual Pascal     }
{ with some minor adjustments                                        }
{                                                                    }
{ A d d r e s s e s   t o   t h e   a u t h o r                      }
{ı}
{ Regular mail:              Electronic mail:                        }
{ Peter Karlsson             Internet: pk@abc.se dat95pkn@idt.mdh.se }
{ Vrnsta, Ullerster        Fidonet:  2:206/221.0                   }
{ S-718 92  FRVI            Fax:      +46-(0)581-32110              }
{ SWEDEN                                                             }
{                                                                    }
{ S t a t u s   o f   t h e   p r o g r a m                          }
{ı}
{ This program is freeware. This means that you have all rights to   }
{ freely distribute and use the program. The author will though      }
{ retain all rights to the program. It may not be modified in any    }
{ way. See above for address. When you distribute this program, make }
{ sure that all files described below are included.                  }
{                                                                    }
{ You may change the programs to suit your own needs, but you do not }
{ have the rights to distribute such a changed file. If you think    }
{ that your change is useful, please send a file describing your     }
{ changes to me, at the address above. The best way if you could     }
{ use the DOS command FC to make a file containing the changes:      }
{                                                                    }
{    FC old_file_name new_file_name > KILLEOF.DIF                    }
{                                                                    }
{ Then send me KILLEOF.DIF, as a print-out, a netmail message or a   }
{ netmail file-attach. Please include your name and address(es).     }
{                                                                    }
{ Everyone who contributes will be mentioned here!                   }
{                                                                    }
{ D i s c l a i m e r   O f   W a r r a n t y                        }
{ı}
{ THIS PROGRAM IS DISTRIBUTED AS-IS. THE PROGRAMMER GIVES NO         }
{ WARRANTY, NOR EXPRESS OR IMPLIED, AS TO THE FUNCTION OF THIS       }
{ PROGRAM. IN NO EVENT SHALL THE PROGRAMMER BE LIABLE FOR ANY DAMAGE }
{ WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF     }
{ BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF BUSINESS          }
{ INFORMATION, OR OTHER PECUNIARY LOSS) ARISING OUT OF THE USE, OR   }
{ INABILITY TO USE, THIS PROGRAM, EVEN IF THE PROGRAMMER HAS BEEN    }
{ ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. WHEN USING THE PROGRAM }
{ YOU AUTOMATICALLY ACCEPT THESE TERMS.                              }
{                                                                    }
{ I n c l u d e d   f i l e s                                        }
{ı}
{   KILLEOF.PAS   This source code / documentation file              }
{   KILLEOF.EXE   The executable program, DOS version                }
{   KILLEOFP.EXE  The executable program, OS/2 version               }
{   KILLEOFX.EXE  The executable program, Win95 version              }
{   FILE_ID.DIZ   Description file for BBS:es                        }
{   WOLVES.COM    Softwolves program catalogue                       }
{                                                                    }
{ FREEWARE }

Program KillEOF;

var
  infil, utfil:         file;
  buffer:               array[0..255] of char;
  {$IFDEF OS2}
  num, count, count2:   longword;
  {$ENDIF}
  {$IFDEF Win95}
  num, count, count2:   longword;
  {$ENDIF}
  {$IFDEF MSDOS}
  num, count, count2:   word;
  {$ENDIF}
  removed:              boolean;
begin
  if ParamCount <> 2 then begin
     {$IFDEF MSDOS}
     Writeln('killEOF/DOS');
     {$ENDIF}
     {$IFDEF OS2}
     Writeln('killEOF/OS2');
     {$ENDIF}
     {$IFDEF Win95}
     Writeln('killEOF/Win95');
     {$ENDIF}
     Writeln;
     Writeln('KILLEOF [drive:][path]filename1 [drive:][path]filename2');
     Writeln;
     Writeln('  filename1   File that EOFs will be stripped from');
     Writeln('  filename2   The file that will be written');
     Halt;
  end;
  Assign(infil, paramstr(1));
  Assign(utfil, paramstr(2));
  {$I-}
  Reset(infil, 1);
  If IOResult <> 0 then begin
    Writeln('The input file could not be opened.');
    Halt(1);
  end;
  Rewrite(utfil, 1);
  If IOResult <> 0 then begin
    Writeln('The output file could not be created.');
    Halt(1);
  end;
  {$I+}
  Blockread(infil, buffer, sizeof(buffer), num);
  While num = sizeof(buffer) do begin
    Repeat
      removed := false;
      count := 0;
      While (count < num) and (buffer[count] <> #26) do
        Inc(count);
      If count<>num then begin
        for count2 := count to 254 do
           buffer[count2] := buffer[count2+1];
        removed := true;
        Dec(num);
      end; { if }
    Until removed = false;
    Blockwrite(utfil, buffer, num, num);
    Blockread(infil, buffer, sizeof(buffer), num);
  end; { while }
  Repeat
    removed := false;
    count := 0;
    While (count < num) and (buffer[count] <> #26) do
      Inc(count);
    If count<>num then begin
      for count2 := count to 254 do
         buffer[count2] := buffer[count2+1];
      removed := true;
      Dec(num);
    end; { if }
  Until removed = false;
  Blockwrite(utfil, buffer, num, num);
  Close(infil);
  Close(utfil);
end.
