;
; mark.asm      September 22, 1991
;
; Copyright (c) AnDan Software 1989-1991
;
; Shareware: This source code may be copied if no fee is charged,
; if no changes are done, and as no part of other products, for
; educate purposes only.
;
; If you have questions, comments or find bugs in the program,
; please send electronic mail to the author, Anders Danielsson
; FidoNet 2:203/101. You may call the BBS AnDan & SDS, where the
; newest versions and other AnDan Software programs always are
; downloadable for all users. Telephone +46-31-307364, 1200 bps
; V.22, 2400 bps V.22bis, 9600 bps USR-HST and V.32, 14400 bps USR-
; HST and V.32bis, MNP Level 5, V.42 and V.42bis, 8 data bits, no
; parity, and 1 stop bit.
;
; Revision history:
;
; Vers: Date:   Comments:
;
; 1.00  891104  First release.
; 1.01  900111  Drive specification may be 0 for current disk.
;               $CD added, will print current disk letter.
; 1.10  910217  All code checked.
;               $Pxx changed to $Pxxx. $Axxx added.
; 1.11  910922  Minor changes.
;
;

COM             SEGMENT WORD PUBLIC 'CODE'

                ASSUME CS:COM,DS:COM,SS:COM,ES:COM

                ORG 0100H

start_main:     jmp main


doc_txt         DB 13,10
DB 'AnDan Software Mark Version 1.11',13,10
DB 'Copyright (c) Scandinavian Digital Systems AB 1991',13,10
DB 13,10
DB 'Shareware: May be copied and distributed if no fee is charged, if no changes',13,10
DB 'are done, and as no part of other products. Please make a contribution to:',13,10
DB 'Scandinavian Digital Systems AB, P.O. Box 24, S-440 42  Alafors, Sweden',13,10
DB 'Voice +46-31-316074, Fax +46-31-319060, Modem/Data/BBS +46-31-307364 (8N1)',13,10
DB 13,10
DB 'mark any text string, that will be sent to STDOUT [>>file]',13,10
DB 13,10
DB 'The text string may contain the following commands:',13,10
DB 13,10
DB '$$      The character $',13,10
DB '$N      The newline characters ASCII 13 and 10',13,10
DB '$Axxx   The character with the ASCII value xxx (000 - 255)',13,10
DB '$Pxxx   Write until position xxx (000 - 255)',13,10
DB '$DC     Century, 19 or 20',13,10
DB '$DY     Year, 00 - 99',13,10
DB '$DM1    Month, 01 - 12',13,10
DB '$DM2    Month, short names of 3 characters, like "Jan"',13,10
DB '$DM3    Month, full names, like "January"',13,10
DB '$DD1    Day, 01 - 31',13,10
DB '$DD2    Day, 1 - 31',13,10
DB '$DD3    Day, short names of 2 characters, like "Mo"',13,10
DB '$DD4    Day, full names, like "Monday"',13,10
DB '$TH     Hour, 00 - 23',13,10
DB '$TM     Minutes, 00 - 59',13,10
DB '$TS     Seconds, 00 - 59',13,10
DB '$DSxB   Disk Size in Bytes for drive x (A - Z or 0 for current drive)',13,10
DB '$DSxK   Disk Size in Kb for drive x (A - Z or 0)',13,10
DB '$DSxM   Disk Size in Mb for drive x (A - Z or 0)',13,10
DB '$DFxB   Disk Free Space in Bytes for drive x (A - Z or 0)',13,10
DB '$DFxK   Disk Free Space in Kb for drive x (A - Z or 0)',13,10
DB '$DFxM   Disk Free Space in Mb for drive x (A - Z or 0)',13,10
DB '$CD     Current disk (A - Z)',13,10
DB 13,10
DB 'All commands must be given with capital letters.',13,10

doc_len         EQU $-doc_txt

txt_months      DB 'January',0
                DB 'February',0
                DB 'March',0
                DB 'April',0
                DB 'May',0
                DB 'June',0
                DB 'July',0
                DB 'August',0
                DB 'September',0
                DB 'October',0
                DB 'November',0
                DB 'December',0

txt_days        DB 'Sunday',0
                DB 'Monday',0
                DB 'Tuesday',0
                DB 'Wednesday',0
                DB 'Thursday',0
                DB 'Friday',0
                DB 'Saturday',0

cent            DB 0
year            DB 0
month           DB 0
day             DB 0
wday            DB 0
hour            DB 0
minute          DB 0
second          DB 0

;
; utoa
;
; In:  AL = Vaule, 00 to 99
;
; utoa1  No leading zeroes
; utoa2  Leading zeroes
;
utoa1:          and al,al
                jz utoas3
                xor cl,cl
                jmp SHORT utoas

utoa2:          mov cl,1

utoas:          mov bl,10
                call utoas1
                mov bl,1
utoas1:         and cl,cl
                jnz utoas2
                cmp al,bl
                jb utoas4
                inc cl
utoas2:         xor ah,ah
                div bl
utoas3:         add al,48
                stosb
                mov al,ah
utoas4:         ret


ltoa_tab        DD 1000000000
                DD 100000000
                DD 10000000
                DD 1000000
                DD 100000
                DD 10000
                DD 1000
                DD 100
                DD 10
                DD 1
;
; ltoa
;
; In:  DX:AX = 32 bit unsigned integer
;
ltoa:           push si
                xor cl,cl
                mov ch,10
                mov si,OFFSET ltoa_tab

ltoa1:          xor bl,bl
ltoa2:          sub ax,[si]
                sbb dx,[si+2]
                jc ltoa3
                inc bl
                jmp ltoa2

ltoa3:          add ax,[si]
                adc dx,[si+2]
                add si,4
                and bl,bl
                jnz ltoa4
                and cl,cl
                jnz ltoa4
                dec ch
                jnz ltoa1
                inc ch

ltoa4:          inc cl
                xchg al,bl
                add al,48
                stosb
                xchg al,bl
                dec ch
                jnz ltoa1
                pop si
                ret

;
; pr_index
;
; In:  DS:DX = Text table
;         AL = Index, start zero
;         CL = Max chars to print
;
pr_index:       push si
                mov si,dx
                mov bl,al
                and bl,bl
                jz pr_index2
pr_index1:      lodsb
                and al,al
                jnz pr_index1
                dec bl
                jnz pr_index1

pr_index2:      lodsb
                and al,al
                jz pr_index3
                stosb
                dec cl
                jnz pr_index2

pr_index3:      pop si
                ret

div1024:        mov al,ah
                mov ah,dl
                mov dl,dh
                xor dh,dh
                shr dx,1
                rcr ax,1
                shr dx,1
                rcr ax,1
                ret

;
; atous_3
;
atous_3:        xor cx,cx
                lodsb
                call atous
                jc atous2
                lodsb
                call atous
                jc atous2
                lodsb
;
; atous
;
atous:          xor ah,ah
                cmp al,'0'
                jb atous1
                cmp al,'9'
                ja atous1
                sub al,'0'
                mov bx,ax
                mov ax,10
                mul cx
                add ax,bx
                mov cx,ax
                clc
                ret
atous1:         stc
atous2:         ret


;
; main
;
; Start of program
;
main:           cld                     ;Clear direction flag
                mov bx,OFFSET COM:stack_start
                cmp bx,sp
                ja quit                 ;Not enough memory, exit program
                mov sp,bx
                mov cl,4
                shr bx,cl
                mov ah,4AH              ;Realloc memory
                int 21H
                jc quit                 ;Impossible error

date:           mov ah,2CH
                int 21H
                mov [hour],ch
                mov [minute],cl
                mov [second],dh
                mov ah,2AH
                int 21H
                mov WORD PTR [cent],cx
                mov [month],dh
                mov [day],dl
                mov [wday],al
                mov ah,2CH
                int 21H
                cmp dh,[second]
                jnz date
                mov ax,WORD PTR [cent]
                xor dx,dx
                mov bx,100
                div bx
                mov [cent],al
                mov [year],dl

                mov di,OFFSET buffer
                mov si,81H
                lodsb
                cmp al,13
                jz main1
                cmp BYTE PTR [si],13
                jnz parse2
main1:          mov dx,OFFSET doc_txt
                mov cx,doc_len
main2:          mov bx,1
                mov ah,40H
                int 21H
quit:           mov ax,4C00H
                int 21H
fail:           jmp fail

print:          mov cx,di
                mov dx,OFFSET buffer
                sub cx,dx
                jmp main2

parse1:         stosb
parse2:         lodsb
parse3:         cmp al,13
                jz print
                cmp al,'$'
                jnz parse1
                lodsb
                cmp al,'$'
                jz parse1
                cmp al,'T'
                jz com_t
                cmp al,'A'
                jz com_a
                cmp al,'P'
                jz com_p
                cmp al,'D'
                jz com_d
                cmp al,'C'
                jz com_c
                cmp al,'N'
                jnz parse3
                mov al,13
                stosb
                mov al,10
                jmp parse1

com_c:          lodsb
                cmp al,'D'
                jnz parse3
                mov ah,19H
                int 21H
                add al,'A'
                jmp parse1

com_t:          lodsb
                cmp al,'H'
                jz com_th
                cmp al,'M'
                jz com_tm
                cmp al,'S'
                jz com_ts
                jmp parse3

com_th:         mov al,[hour]
                jmp com_dc1

com_tm:         mov al,[minute]
                jmp com_dc1

com_ts:         mov al,[second]
                jmp com_dc1

com_a:          call atous_3
                jc parse3
                mov al,cl
                jmp parse1

com_p:          call atous_3
                jc parse3
                mov al,32
                mov bx,di
                sub bx,OFFSET buffer
                inc bx
                sub cx,bx
                jbe parse2
                rep stosb
                jmp parse2

com_d:          lodsb
                cmp al,'C'
                jz com_dc
                cmp al,'Y'
                jz com_dy
                cmp al,'M'
                jz com_dm
                cmp al,'D'
                jz com_dd
                xor cl,cl
                cmp al,'S'
                jz com_disk
                inc cl
                cmp al,'F'
                jz com_disk
                jmp parse3

com_dc:         mov al,[cent]
com_dc1:        call utoa2
                jmp parse2

com_dy:         mov al,[year]
                jmp com_dc1

com_dm:         lodsb
                cmp al,'1'
                jz com_dm1
                cmp al,'2'
                jz com_dm2
                xor cl,cl
                cmp al,'3'
                jz com_dm3
                jmp parse3

com_dm1:        mov al,[month]
                jmp com_dc1

com_dm2:        mov cl,3
com_dm3:        mov dx,OFFSET txt_months
                mov al,[month]
                dec al
                call pr_index
                jmp parse2

com_dd:         lodsb
                cmp al,'1'
                jz com_dd1
                cmp al,'2'
                jz com_dd2
                cmp al,'3'
                jz com_dd3
                xor cl,cl
                cmp al,'4'
                jz com_dd4
                jmp parse3

com_dd1:        mov al,[day]
                jmp com_dc1

com_dd2:        mov al,[day]
                call utoa1
                jmp parse2

com_dd3:        mov cl,2
com_dd4:        mov dx,OFFSET txt_days
                mov al,[wday]
                call pr_index
                jmp parse2

com_disk:       lodsb
                xor dl,dl
                cmp al,'0'
                jz com_disk0
                cmp al,'A'
                jb com_disk3
                cmp al,'Z'
                ja com_disk3
                sub al,64
                mov dl,al
com_disk0:      push cx
                mov ah,36H
                int 21H
                cmp ax,0FFFFH
                jnz com_disk1
                xor ax,ax
com_disk1:      mov bp,dx
                mul cx
                pop cx
                and cl,cl
                jnz com_disk2
                mov bx,bp
com_disk2:      mul bx

                mov cl,[si]
                cmp cl,'B'
                jz com_disk4
                call div1024
                cmp cl,'K'
                jz com_disk4
                call div1024
                cmp cl,'M'
                jz com_disk4
com_disk3:      jmp parse3

com_disk4:      inc si
                call ltoa
                jmp parse2

                EVEN

buffer          EQU $

COM             ENDS

STACK           SEGMENT PARA PUBLIC 'STACK'     ;Note, PUBLIC and not STACK
                                                ;for .COM-programs.

stack_start     EQU $+256+1024  ;256 bytes for 'buffer'

STACK           ENDS

                END start_main
